var palette, textarea, mainForm, submitButton, responseArea;
var pendingRequest;

function readystatechange_fn(req)
{
	return function() {
		if (req.readyState == 4) {
			if (req.status != 200) {
				responseArea.innerHTML = '<p>(Hmm, internal error.  Bogus response from renderer.)</p>';
			} else {
				responseArea.innerHTML = req.responseText;
			}

			if (pendingRequest == req) {
				pendingRequest = null;
				submitButton.disabled = false;
			}
		}
	};
}

function form_submitted(event)
{
	event.preventDefault();
	if (pendingRequest != null) return;

	var request = new XMLHttpRequest();
	request.onreadystatechange = readystatechange_fn(request);
	var targetURI = 'render.cgi?w=' + encodeURIComponent(textarea.value);
	request.open('GET', targetURI, true);
	request.setRequestHeader('Connection', 'close');
	pendingRequest = request;
	request.send(null);

	submitButton.disabled = true;
	return true;
}

function child_clicked_fn(child, text)
{
	return function(event) {
		if (textarea.value.length > 0) textarea.value += ' ';
		textarea.value += text;	
		event.preventDefault();
		return true;
	};
}

function do_init()
{
	palette = document.getElementById('palette');
	textarea = document.getElementById('textarea');
	mainForm = document.getElementById('mainForm');
	submitButton = document.getElementById('submitButton');
	responseArea = document.getElementById('responseArea');

	for (var child = palette.firstChild; child != null; child = child.nextSibling) {
		var text = child.firstChild.data;
		child.addEventListener('click', child_clicked_fn(child, text), false);
	}

	mainForm.addEventListener('submit', form_submitted, false);
	document.getElementById('clearButton').disabled = false;
}

function do_clear()
{
	if (textarea == null) return;
	textarea.value = '';
}
